%define 	pname daemontools
%define 	pversion 0.76
%define 	bversion 122
%define 	rpmrelease iworx
%define 	cmddir /command
%define 	srvdir /service

%define 	debug_package %{nil}

# INSTRUCTIONS!!! <--------------------- READ THEM!!!
#
# You can rebuild  this  package safely using Command 
# Line Overrides. For example, if you want to rebuild
# this package for RedHat just type:
# $ rpm --rebuild --with redhat package.src.rpm
# $ rpm -ba --with redhat package.spec
#
# mdk = GNU/Linux Mandrake
# rht = Linux Red-Hat
# sus = Suse Linux
# fdr = Fedora Linux
# cos = CentOS
# whb = White Box Linux
# rhe = Red Hat Enterprise
# unk = Unknown
#

%define		build_rhe_6x   0
%define		build_rhe_7x   0
%define		build_rhe_8x   0

%define		build_unk      1

# Command Line Overrides
%{?_with_rhe6x: 	%{expand: %%define build_rhe_6x   1}}
%{?_with_rhe7x: 	%{expand: %%define build_rhe_7x   1}}
%{?_with_rhe8x: 	%{expand: %%define build_rhe_8x   1}}

%{?_with_unk: 		%{expand: %%define build_unk      1}}

# Distro Statements
%if %{build_rhe_6x}
%define		oscode rhe6x
%define 	ostype RedHat Enterprise 6.x
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rhe_7x}
%define		oscode rhe7x
%define 	ostype RedHat Enterprise 7.x
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rhe_8x}
%define         oscode rhe8x
%define         ostype Almalinux 8.x
%define         ccflags %{optflags}
%define         ldflags %{optflags}
%define         build_unk 0
%endif

%define	release %{bversion}.%{oscode}.%{rpmrelease}

##
# THIS MUST BE LAST
##

%if %{build_unk}
%define		oscode unk
%define 	ostype Unknown Distribution
%define		release %{bversion}.%{rpmrelease}
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%endif

############### RPM ################################

Summary:	DJB daemontools
Name:		%{pname}
Version:	%{pversion}
Release:	%{release}
License:	DJB

Group:		System/Servers
Source0:	daemontools-%{pversion}.tar.bz2
URL:		http://cr.yp.to/daemontools.html

Distribution:	InterWorx-HAL
Vendor:         INTERWORX L.L.C.
Packager:	Tim College <tcollege@interworx.com>

Buildroot:	%{_tmppath}/%{name}-%{version}-root

Obsoletes:	daemontools-toaster

Source1:	daemontools-%{pversion}-man.tar.bz2
Source2:	svscanboot-upstart.config
Source3:	svscanboot.service

Patch0:         interworx-disable-chkshsgr-test.patch

Requires:	grep
#Requires(post): /sbin/init
Requires:	/etc/inittab
 
%description
Supervise monitors a service. It starts the service and restarts the
service if it dies.  The companion  svc program  stops,  pauses,  or
restarts the service on sysadmin request.  The svstat program prints
a one-line status report.

Multilog saves error  messages to  one or more  logs.  It optionally
timestamps each line and,  for each log,  includes or excludes lines
matching specified patterns.  It automatically rotates logs to limit
the amount of disk space used.   If the disk fills up, it pauses and
tries again, without losing any data.

%package 	doc
Summary:        Daemontools documentation
Group:          Documentation
Obsoletes:	daemontools-toaster-doc
Requires:       %{name} = %{version}

%description 	doc
Supervise documentation (man pages):  supervise  starts the  service
and restarts the service if it dies. The companion svc program stops,
pauses, or  restarts  the  service on  sysadmin  request. The svstat
program prints a one-line status report.

Multilog documentation (man pages): multilog saves error messages to
one or more logs.  It optionally  timestamps each line and, for each
log,  includes or excludes  lines  matching specified  patterns.  It
automatically rotates logs to  limit the amount  of disk  space used.
If the disk fills up, it pauses  and tries again, without losing any
data.

%prep

%define name daemontools
%setup -q -n %{name}-%{pversion}
%setup -q -T -D -c -a 1 -n %{name}-%{pversion}

%patch0 -p2

# Try detecting newest gcc (some distributions have got more then one compiler)
[ -f %{_tmppath}/%{name}-%{pversion}-gcc ] && rm -f %{_tmppath}/%{name}-%{pversion}-gcc

if   [ -x /usr/bin/gcc-3.2.3 ]; then
	echo "/usr/bin/gcc-3.2.3" > %{_tmppath}/%{name}-%{pversion}-gcc
elif   [ -x /usr/bin/gcc-3.2.2 ]; then
	echo "/usr/bin/gcc-3.2.2" > %{_tmppath}/%{name}-%{pversion}-gcc
elif   [ -x /usr/bin/gcc-3.2.1 ]; then
	echo "/usr/bin/gcc-3.2.1" > %{_tmppath}/%{name}-%{pversion}-gcc
elif [ -x /usr/bin/gcc-3.2 ]; then
        echo "/usr/bin/gcc-3.2" > %{_tmppath}/%{name}-%{pversion}-gcc
elif [ -x /usr/bin/gcc-3.1.1 ]; then
        echo "/usr/bin/gcc-3.1.1" > %{_tmppath}/%{name}-%{pversion}-gcc
else
	echo "gcc" > %{_tmppath}/%{name}-%{pversion}-gcc
fi

# Display compilation flags and OS with nice colors
[ -f %{_tmppath}/%{name}-%{pversion}-show_flags ] && rm -f %{_tmppath}/%{name}-%{pversion}-show_flags
cat <<EOF >>%{_tmppath}/%{name}-%{pversion}-show_flags
#!/bin/sh

RPM="RPM RELEASE: \033[40m\033[001;033m%{release}"
OS="OS TYPE IS : \033[40m\033[001;033m%{ostype}"
GCC="GCC IS     : \033[40m\033[001;033m`cat %{_tmppath}/%{name}-%{pversion}-gcc`"
CCF="CCFLAGS    : \033[40m\033[001;033m%{ccflags}"
LDF="LDFLAGS    : \033[40m\033[001;033m%{ldflags}"

echo
echo
echo -e "\033[40m\033[001;031m\$RPM\033[0m"
echo -e "\033[40m\033[001;031m\$OS\033[0m"
echo -e "\033[40m\033[001;031m\$GCC\033[0m"
echo -e "\033[40m\033[001;031m\$CCF\033[0m"
echo -e "\033[40m\033[001;031m\$LDF\033[0m"
echo
echo

sleep 5

EOF

# Take care to execute and then to delete
chmod u+x %{_tmppath}/%{name}-%{pversion}-show_flags
%{_tmppath}/%{name}-%{pversion}-show_flags
[ -f %{_tmppath}/%{name}-%{pversion}-show_flags ] && rm -f %{_tmppath}/%{name}-%{pversion}-show_flags

%build

[ -n "%{buildroot}" -a "%{buildroot}" != / ] && rm -rf %{buildroot}

mkdir -p %{buildroot}

# We have gcc written in a temp file
echo "`cat %{_tmppath}/%{name}-%{pversion}-gcc` %{ccflags}"    >src/conf-cc
echo "`cat %{_tmppath}/%{name}-%{pversion}-gcc` -s %{ldflags}" >src/conf-ld

# Delete gcc temp file
[ -f %{_tmppath}/%{name}-%{pversion}-gcc ] && rm -f %{_tmppath}/%{name}-%{pversion}-gcc

echo "%{_prefix}" >src/conf-home

# GLIBC fix
echo "Fixing errno.h for new GLIBC"
echo "#include <errno.h>" >> src/error.h
whoami

package/compile || package/compile

%install

mkdir -p %{buildroot}%{_bindir}
mkdir -p %{buildroot}%{_mandir}/man8
mkdir -p %{buildroot}%{cmddir}
mkdir -p %{buildroot}%{srvdir}

install -m 755 command/* %{buildroot}%{_bindir}
install -m 644 %{name}-%{pversion}-man/*.8 %{buildroot}%{_mandir}/man8
for i in `cat package/commands`
do
  ln -s ..%{_bindir}/$i %{buildroot}/command/$i
done

%if %{build_rhe_6x}
    mkdir -p %{buildroot}/etc/init 2> /dev/null || :
    install -m 755 %{SOURCE2} %{buildroot}/etc/init/svscanboot.conf
%endif

%if %{build_rhe_7x}
    mkdir -p %{buildroot}/lib/systemd/system 2> /dev/null || :
    install -m 644 %{SOURCE3} %{buildroot}/lib/systemd/system/svscanboot.service
%endif

%post

# update the inittab so we start on boot
/bin/grep "^SV1:123456:respawn:/usr/bin/svscanboot$" \
	/etc/inittab >/dev/null || \
	echo 'SV1:123456:respawn:/usr/bin/svscanboot' >> /etc/inittab
/sbin/init q || echo -n
%if %{build_rhe_6x}
    /sbin/start --quiet svscanboot > /dev/null 2>&1 || :
%endif

%if %{build_rhe_7x}
    /usr/sbin/service svscanboot start > /dev/null 2>&1 || :
%endif

%preun
if [ "$1" == "0" ]; then
   echo
   echo "WARNING: daemontools package removal request denied.  This package is required by Interworx."
   echo
   exit 1
fi

%clean
[ -n "%{buildroot}" -a "%{buildroot}" != / ] && rm -rf %{buildroot}
[ -d $RPM_BUILD_DIR/%{name}-%{pversion} ] && rm -rf $RPM_BUILD_DIR/%{name}-%{pversion}

%files doc

%attr(0644,root,root) %{_mandir}/man8/envdir.8.*
%attr(0644,root,root) %{_mandir}/man8/envuidgid.8.*
%attr(0644,root,root) %{_mandir}/man8/fghack.8.*
%attr(0644,root,root) %{_mandir}/man8/multilog.8.*
%attr(0644,root,root) %{_mandir}/man8/pgrphack.8.*
%attr(0644,root,root) %{_mandir}/man8/readproctitle.8.*
%attr(0644,root,root) %{_mandir}/man8/setlock.8.*
%attr(0644,root,root) %{_mandir}/man8/setuidgid.8.*
%attr(0644,root,root) %{_mandir}/man8/softlimit.8.*
%attr(0644,root,root) %{_mandir}/man8/supervise.8.*
%attr(0644,root,root) %{_mandir}/man8/svc.8.*
%attr(0644,root,root) %{_mandir}/man8/svok.8.*
%attr(0644,root,root) %{_mandir}/man8/svscan.8.*
%attr(0644,root,root) %{_mandir}/man8/svscanboot.8.*
%attr(0644,root,root) %{_mandir}/man8/svstat.8.*
%attr(0644,root,root) %{_mandir}/man8/tai64n.8.*
%attr(0644,root,root) %{_mandir}/man8/tai64nlocal.8.*

%files
%defattr (-,root,root)
%attr(0644,root,root) %doc src/CHANGES package/README src/TODO
%attr(0755,root,root) %{_bindir}/svscan
%attr(0755,root,root) %{_bindir}/svscanboot
%attr(0755,root,root) %{_bindir}/supervise
%attr(0755,root,root) %{_bindir}/svc
%attr(0755,root,root) %{_bindir}/svok
%attr(0755,root,root) %{_bindir}/svstat
%attr(0755,root,root) %{_bindir}/fghack
%attr(0755,root,root) %{_bindir}/multilog
%attr(0755,root,root) %{_bindir}/pgrphack
%attr(0755,root,root) %{_bindir}/tai64n
%attr(0755,root,root) %{_bindir}/tai64nlocal
%attr(0755,root,root) %{_bindir}/readproctitle
%attr(0755,root,root) %{_bindir}/softlimit
%attr(0755,root,root) %{_bindir}/envuidgid
%attr(0755,root,root) %{_bindir}/envdir
%attr(0755,root,root) %{_bindir}/setlock
%attr(0755,root,root) %{_bindir}/setuidgid
%attr(0755,root,root) %dir %{cmddir}
%attr(0755,root,root) %{cmddir}/*
%attr(0755,root,root) %dir %{srvdir}
%if %{build_rhe_6x}
    %attr(0755,root,root) /etc/init/svscanboot.conf
%endif
%if %{build_rhe_7x}
    %attr(0644,root,root) /lib/systemd/system/svscanboot.service
%endif


%changelog
* Fri Aug 20 2021 Tim College <tcollege@interworx.com>
- Updated for Almalinux 8.x
- Remove EOL OS support
* Tue May 14 2019 Nathan Roth <nroth@interworx.com>
- Updated install permissions for svscanboot.service
* Tue Aug 26 2014 Matt Parmelee <mparmelee@interworx.com>
- Updated for RHEL 7.x
* Tue Jan 03 2012 Paul Oehler <poehler@interworx.com>
- Fixed incorrect installation of /etc/event.d/svscanboot.
* Sun Oct 03 2010 Paul Oehler <poehler@interworx.com>
- Added uninstall blocker preun script
* Thu May 06 2010 Paul Oehler <poehler@interworx.com>
- Updated for RHEL 6.x
* Tue Jun 17 2008 Paul Oehler <poehler@interworx.com>
- Updated for Fedora 9
* Tue May 13 2008 Paul Oehler <poehler@interworx.com>
- Added support for Fedora 8
* Mon Jun 28 2004 Chris Wells <clwells@nexcess.net>
- Initial packaging as part of InterWorx-HAL OS
